=== modified file 'drizzled/connect.h'
--- drizzled/connect.h	2009-03-16 02:52:26 +0000
+++ drizzled/connect.h	2009-05-30 22:30:05 +0000
@@ -28,6 +28,5 @@
 
 extern "C"
 pthread_handler_t handle_one_connection(void *arg);
-bool init_new_connection_handler_thread();
 
 #endif /* DRIZZLE_SERVER_CONNECT_H */

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-05-27 21:11:30 +0000
+++ drizzled/handler.cc	2009-05-30 22:30:05 +0000
@@ -1829,36 +1829,6 @@
 }
 
 
-int handler::ha_check_for_upgrade(HA_CHECK_OPT *check_opt)
-{
-  KEY *keyinfo, *keyend;
-  KEY_PART_INFO *keypart, *keypartend;
-
-  if (!table->s->mysql_version)
-  {
-    /* check for blob-in-key error */
-    keyinfo= table->key_info;
-    keyend= table->key_info + table->s->keys;
-    for (; keyinfo < keyend; keyinfo++)
-    {
-      keypart= keyinfo->key_part;
-      keypartend= keypart + keyinfo->key_parts;
-      for (; keypart < keypartend; keypart++)
-      {
-        if (!keypart->fieldnr)
-          continue;
-        Field *field= table->field[keypart->fieldnr-1];
-        if (field->type() == DRIZZLE_TYPE_BLOB)
-        {
-          return HA_ADMIN_NEEDS_CHECK;
-        }
-      }
-    }
-  }
-  return check_for_upgrade(check_opt);
-}
-
-
 /* Code left, but Drizzle has no legacy yet (while MySQL did) */
 int handler::check_old_types()
 {
@@ -1955,20 +1925,8 @@
   @retval
     HA_ADMIN_NOT_IMPLEMENTED
 */
-int handler::ha_check(Session *session, HA_CHECK_OPT *check_opt)
+int handler::ha_check(Session *, HA_CHECK_OPT *)
 {
-  int error;
-
-  if (table->s->mysql_version < DRIZZLE_VERSION_ID)
-  {
-    if ((error= check_old_types()))
-      return error;
-    error= ha_check_for_upgrade(check_opt);
-    if (error && (error != HA_ADMIN_NEEDS_CHECK))
-      return error;
-  }
-  if ((error= check(session, check_opt)))
-    return error;
   return HA_ADMIN_OK;
 }
 
@@ -3474,7 +3432,7 @@
   - table is not mysql.event
 */
 
-static bool binlog_log_row(Table* table,
+static bool log_row_for_replication(Table* table,
                            const unsigned char *before_record,
                            const unsigned char *after_record)
 {
@@ -3572,7 +3530,7 @@
   if (unlikely(error= write_row(buf)))
     return(error);
 
-  if (unlikely(binlog_log_row(table, 0, buf)))
+  if (unlikely(log_row_for_replication(table, 0, buf)))
     return HA_ERR_RBR_LOGGING_FAILED; /* purecov: inspected */
 
   DRIZZLE_INSERT_ROW_END();
@@ -3595,7 +3553,7 @@
   if (unlikely(error= update_row(old_data, new_data)))
     return error;
 
-  if (unlikely(binlog_log_row(table, old_data, new_data)))
+  if (unlikely(log_row_for_replication(table, old_data, new_data)))
     return HA_ERR_RBR_LOGGING_FAILED;
 
   return 0;
@@ -3610,7 +3568,7 @@
   if (unlikely(error= delete_row(buf)))
     return error;
 
-  if (unlikely(binlog_log_row(table, buf, 0)))
+  if (unlikely(log_row_for_replication(table, buf, 0)))
     return HA_ERR_RBR_LOGGING_FAILED;
 
   return 0;

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2009-05-29 17:43:49 +0000
+++ drizzled/handler.h	2009-05-30 22:30:05 +0000
@@ -280,7 +280,6 @@
   int ha_delete_row(const unsigned char * buf);
   void ha_release_auto_increment();
 
-  int ha_check_for_upgrade(HA_CHECK_OPT *check_opt);
   /** to be actually called to get 'check()' functionality*/
   int ha_check(Session *session, HA_CHECK_OPT *check_opt);
   int ha_repair(Session* session, HA_CHECK_OPT* check_opt);

=== modified file 'drizzled/server_includes.h'
--- drizzled/server_includes.h	2009-05-27 23:03:42 +0000
+++ drizzled/server_includes.h	2009-05-30 22:30:05 +0000
@@ -190,7 +190,6 @@
 int open_table_from_share(Session *session, TableShare *share, const char *alias,
                           uint32_t db_stat, uint32_t prgflag, uint32_t ha_open_flags,
                           Table *outparam, open_table_mode open_mode);
-int read_string(File file, unsigned char* *to, size_t length);
 void free_blobs(Table *table);
 int set_zone(int nr,int min_zone,int max_zone);
 uint32_t convert_period_to_month(uint32_t period);
@@ -245,8 +244,6 @@
 TYPELIB *convert_strings_to_array_type(char * *typelibs, char * *end);
 TYPELIB *typelib(MEM_ROOT *mem_root, List<String> &strings);
 ulong get_form_pos(File file, unsigned char *head, TYPELIB *save_names);
-off_t make_new_entry(File file,unsigned char *fileinfo,TYPELIB *formnames,
-		     const char *newname);
 ulong next_io_size(ulong pos);
 void append_unescaped(String *res, const char *pos, uint32_t length);
 int rename_table_proto_file(const char *from, const char* to);
@@ -255,8 +252,6 @@
 bool check_db_name(LEX_STRING *db);
 bool check_column_name(const char *name);
 bool check_table_name(const char *name, uint32_t length);
-char *get_field(MEM_ROOT *mem, Field *field);
-bool get_field(MEM_ROOT *mem, Field *field, class String *res);
 char *fn_rext(char *name);
 
 /* Conversion functions */

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2009-05-29 22:40:43 +0000
+++ drizzled/session.cc	2009-05-30 22:30:05 +0000
@@ -399,7 +399,7 @@
   if (locked_tables)
   {
     lock=locked_tables; locked_tables=0;
-    close_thread_tables(this);
+    close_thread_tables();
   }
   hash_free(&user_vars);
   close_temporary_tables();
@@ -821,7 +821,7 @@
   {
     lock= locked_tables;
     locked_tables= 0;			// Will be automatically closed
-    close_thread_tables(this);			// Free tables
+    close_thread_tables();			// Free tables
   }
   if (! endActiveTransaction())
     result= false;
@@ -2116,3 +2116,167 @@
 
   return entry;
 }
+
+/**
+  Mark all temporary tables which were used by the current statement or
+  substatement as free for reuse, but only if the query_id can be cleared.
+
+  @param session thread context
+
+  @remark For temp tables associated with a open SQL HANDLER the query_id
+          is not reset until the HANDLER is closed.
+*/
+
+void Session::mark_temp_tables_as_free_for_reuse()
+{
+  for (Table *table= temporary_tables ; table ; table= table->next)
+  {
+    if (table->query_id == query_id)
+    {
+      table->query_id= 0;
+      table->file->ha_reset();
+    }
+  }
+}
+
+
+/*
+  Mark all tables in the list which were used by current substatement
+  as free for reuse.
+
+  SYNOPSIS
+    mark_used_tables_as_free_for_reuse()
+      session   - thread context
+      table - head of the list of tables
+
+  DESCRIPTION
+    Marks all tables in the list which were used by current substatement
+    (they are marked by its query_id) as free for reuse.
+
+  NOTE
+    The reason we reset query_id is that it's not enough to just test
+    if table->query_id != session->query_id to know if a table is in use.
+
+    For example
+    SELECT f1_that_uses_t1() FROM t1;
+    In f1_that_uses_t1() we will see one instance of t1 where query_id is
+    set to query_id of original query.
+*/
+
+void Session::mark_used_tables_as_free_for_reuse(Table *table)
+{
+  for (; table ; table= table->next)
+  {
+    if (table->query_id == query_id)
+    {
+      table->query_id= 0;
+      table->file->ha_reset();
+    }
+  }
+}
+
+
+/*
+  Close all tables used by the current substatement, or all tables
+  used by this thread if we are on the upper level.
+
+  SYNOPSIS
+    close_thread_tables()
+    session			Thread handler
+
+  IMPLEMENTATION
+    Unlocks tables and frees derived tables.
+    Put all normal tables used by thread in free list.
+
+    It will only close/mark as free for reuse tables opened by this
+    substatement, it will also check if we are closing tables after
+    execution of complete query (i.e. we are on upper level) and will
+    leave prelocked mode if needed.
+*/
+
+void Session::close_thread_tables()
+{
+  Table *table;
+
+  /*
+    We are assuming here that session->derived_tables contains ONLY derived
+    tables for this substatement. i.e. instead of approach which uses
+    query_id matching for determining which of the derived tables belong
+    to this substatement we rely on the ability of substatements to
+    save/restore session->derived_tables during their execution.
+
+    TODO: Probably even better approach is to simply associate list of
+          derived tables with (sub-)statement instead of thread and destroy
+          them at the end of its execution.
+  */
+  if (derived_tables)
+  {
+    Table *next;
+    /*
+      Close all derived tables generated in queries like
+      SELECT * FROM (SELECT * FROM t1)
+    */
+    for (table= derived_tables ; table ; table= next)
+    {
+      next= table->next;
+      table->free_tmp_table(this);
+    }
+    derived_tables= 0;
+  }
+
+  /*
+    Mark all temporary tables used by this statement as free for reuse.
+  */
+  mark_temp_tables_as_free_for_reuse();
+  /*
+    Let us commit transaction for statement. Since in 5.0 we only have
+    one statement transaction and don't allow several nested statement
+    transactions this call will do nothing if we are inside of stored
+    function or trigger (i.e. statement transaction is already active and
+    does not belong to statement for which we do close_thread_tables()).
+    TODO: This should be fixed in later releases.
+   */
+  if (!(state_flags & Open_tables_state::BACKUPS_AVAIL))
+  {
+    main_da.can_overwrite_status= true;
+    ha_autocommit_or_rollback(this, is_error());
+    main_da.can_overwrite_status= false;
+    transaction.stmt.reset();
+  }
+
+  if (locked_tables)
+  {
+
+    /* Ensure we are calling ha_reset() for all used tables */
+    mark_used_tables_as_free_for_reuse(open_tables);
+
+    /*
+      We are under simple LOCK TABLES so should not do anything else.
+    */
+    return;
+  }
+
+  if (lock)
+  {
+    /*
+      For RBR we flush the pending event just before we unlock all the
+      tables.  This means that we are at the end of a topmost
+      statement, so we ensure that the STMT_END_F flag is set on the
+      pending event.  For statements that are *inside* stored
+      functions, the pending event will not be flushed: that will be
+      handled either before writing a query log event (inside
+      binlog_query()) or when preparing a pending event.
+     */
+    mysql_unlock_tables(this, lock);
+    lock= 0;
+  }
+  /*
+    Note that we need to hold LOCK_open while changing the
+    open_tables list. Another thread may work on it.
+    (See: remove_table_from_cache(), mysql_wait_completed_table())
+    Closing a MERGE child before the parent would be fatal if the
+    other thread tries to abort the MERGE lock in between.
+  */
+  if (open_tables)
+    close_open_tables();
+}

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-05-29 22:40:43 +0000
+++ drizzled/session.h	2009-05-30 22:30:05 +0000
@@ -428,16 +428,18 @@
   THR_LOCK_OWNER *lock_id;              // If not main_lock_id, points to
                                         // the lock_id of a cursor.
   pthread_mutex_t LOCK_delete;		// Locked before session is deleted
+
   /*
     A peek into the query string for the session. This is a best effort
     delivery, there is no guarantee whether the content is meaningful.
   */
   char process_list_info[PROCESS_LIST_WIDTH+1];
+
   /*
     A pointer to the stack frame of handle_one_connection(),
     which is called first in the thread for handling a client
   */
-  char	  *thread_stack;
+  char *thread_stack;
 
   /**
     Currently selected catalog.
@@ -1187,6 +1189,11 @@
   */
   MEM_ROOT main_mem_root;
 
+  /* This is currently in sql_base.cc and should be refactored into session.cc */
+  void close_open_tables();
+  void mark_used_tables_as_free_for_reuse(Table *table);
+  void mark_temp_tables_as_free_for_reuse();
+
 public:
   /** A short cut for session->main_da.set_ok_status(). */
   inline void my_ok(ha_rows affected_rows= 0, uint64_t passed_id= 0, const char *message= NULL)
@@ -1225,6 +1232,7 @@
   }
   void refresh_status();
   user_var_entry *getVariable(LEX_STRING &name, bool create_if_not_exists);
+  void close_thread_tables();
 };
 
 /*

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-05-30 01:39:28 +0000
+++ drizzled/sql_base.cc	2009-05-30 22:30:05 +0000
@@ -802,65 +802,6 @@
 
 
 /**
-  Mark all temporary tables which were used by the current statement or
-  substatement as free for reuse, but only if the query_id can be cleared.
-
-  @param session thread context
-
-  @remark For temp tables associated with a open SQL HANDLER the query_id
-          is not reset until the HANDLER is closed.
-*/
-
-static void mark_temp_tables_as_free_for_reuse(Session *session)
-{
-  for (Table *table= session->temporary_tables ; table ; table= table->next)
-  {
-    if (table->query_id == session->query_id)
-    {
-      table->query_id= 0;
-      table->file->ha_reset();
-    }
-  }
-}
-
-
-/*
-  Mark all tables in the list which were used by current substatement
-  as free for reuse.
-
-  SYNOPSIS
-    mark_used_tables_as_free_for_reuse()
-      session   - thread context
-      table - head of the list of tables
-
-  DESCRIPTION
-    Marks all tables in the list which were used by current substatement
-    (they are marked by its query_id) as free for reuse.
-
-  NOTE
-    The reason we reset query_id is that it's not enough to just test
-    if table->query_id != session->query_id to know if a table is in use.
-
-    For example
-    SELECT f1_that_uses_t1() FROM t1;
-    In f1_that_uses_t1() we will see one instance of t1 where query_id is
-    set to query_id of original query.
-*/
-
-static void mark_used_tables_as_free_for_reuse(Session *session, Table *table)
-{
-  for (; table ; table= table->next)
-  {
-    if (table->query_id == session->query_id)
-    {
-      table->query_id= 0;
-      table->file->ha_reset();
-    }
-  }
-}
-
-
-/**
   Auxiliary function to close all tables in the open_tables list.
 
   @param session Thread context.
@@ -868,7 +809,7 @@
   @remark It should not ordinarily be called directly.
 */
 
-static void close_open_tables(Session *session)
+void Session::close_open_tables()
 {
   bool found_old_table= 0;
 
@@ -876,9 +817,9 @@
 
   pthread_mutex_lock(&LOCK_open);
 
-  while (session->open_tables)
-    found_old_table|= close_thread_table(session, &session->open_tables);
-  session->some_tables_deleted= 0;
+  while (open_tables)
+    found_old_table|= close_thread_table(this, &open_tables);
+  some_tables_deleted= 0;
 
   /* Free tables to hold down open files */
   while (open_cache.records > table_cache_size && unused_tables)
@@ -893,114 +834,6 @@
 }
 
 
-/*
-  Close all tables used by the current substatement, or all tables
-  used by this thread if we are on the upper level.
-
-  SYNOPSIS
-    close_thread_tables()
-    session			Thread handler
-
-  IMPLEMENTATION
-    Unlocks tables and frees derived tables.
-    Put all normal tables used by thread in free list.
-
-    It will only close/mark as free for reuse tables opened by this
-    substatement, it will also check if we are closing tables after
-    execution of complete query (i.e. we are on upper level) and will
-    leave prelocked mode if needed.
-*/
-
-void close_thread_tables(Session *session)
-{
-  Table *table;
-
-  /*
-    We are assuming here that session->derived_tables contains ONLY derived
-    tables for this substatement. i.e. instead of approach which uses
-    query_id matching for determining which of the derived tables belong
-    to this substatement we rely on the ability of substatements to
-    save/restore session->derived_tables during their execution.
-
-    TODO: Probably even better approach is to simply associate list of
-          derived tables with (sub-)statement instead of thread and destroy
-          them at the end of its execution.
-  */
-  if (session->derived_tables)
-  {
-    Table *next;
-    /*
-      Close all derived tables generated in queries like
-      SELECT * FROM (SELECT * FROM t1)
-    */
-    for (table= session->derived_tables ; table ; table= next)
-    {
-      next= table->next;
-      table->free_tmp_table(session);
-    }
-    session->derived_tables= 0;
-  }
-
-  /*
-    Mark all temporary tables used by this statement as free for reuse.
-  */
-  mark_temp_tables_as_free_for_reuse(session);
-  /*
-    Let us commit transaction for statement. Since in 5.0 we only have
-    one statement transaction and don't allow several nested statement
-    transactions this call will do nothing if we are inside of stored
-    function or trigger (i.e. statement transaction is already active and
-    does not belong to statement for which we do close_thread_tables()).
-    TODO: This should be fixed in later releases.
-   */
-  if (!(session->state_flags & Open_tables_state::BACKUPS_AVAIL))
-  {
-    session->main_da.can_overwrite_status= true;
-    ha_autocommit_or_rollback(session, session->is_error());
-    session->main_da.can_overwrite_status= false;
-    session->transaction.stmt.reset();
-  }
-
-  if (session->locked_tables)
-  {
-
-    /* Ensure we are calling ha_reset() for all used tables */
-    mark_used_tables_as_free_for_reuse(session, session->open_tables);
-
-    /*
-      We are under simple LOCK TABLES so should not do anything else.
-    */
-    return;
-  }
-
-  if (session->lock)
-  {
-    /*
-      For RBR we flush the pending event just before we unlock all the
-      tables.  This means that we are at the end of a topmost
-      statement, so we ensure that the STMT_END_F flag is set on the
-      pending event.  For statements that are *inside* stored
-      functions, the pending event will not be flushed: that will be
-      handled either before writing a query log event (inside
-      binlog_query()) or when preparing a pending event.
-     */
-    mysql_unlock_tables(session, session->lock);
-    session->lock=0;
-  }
-  /*
-    Note that we need to hold LOCK_open while changing the
-    open_tables list. Another thread may work on it.
-    (See: remove_table_from_cache(), mysql_wait_completed_table())
-    Closing a MERGE child before the parent would be fatal if the
-    other thread tries to abort the MERGE lock in between.
-  */
-  if (session->open_tables)
-    close_open_tables(session);
-
-  return;
-}
-
-
 /* move one table to free list */
 
 bool close_thread_table(Session *session, Table **table_ptr)
@@ -3333,7 +3166,7 @@
   session->lex->chop_off_not_own_tables();
   for (TableList *tmp= *tables; tmp; tmp= tmp->next_global)
     tmp->table= 0;
-  close_thread_tables(session);
+  session->close_thread_tables();
 }
 
 

=== modified file 'drizzled/sql_connect.cc'
--- drizzled/sql_connect.cc	2009-04-09 01:11:00 +0000
+++ drizzled/sql_connect.cc	2009-05-30 22:30:05 +0000
@@ -31,16 +31,6 @@
 
 
 /*
-  Initialize connection threads
-*/
-bool init_new_connection_handler_thread()
-{
-  if (my_thread_init())
-    return 1;
-  return 0;
-}
-
-/*
   Thread handler for a connection
 
   SYNOPSIS

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-05-27 21:11:30 +0000
+++ drizzled/sql_parse.cc	2009-05-30 22:30:05 +0000
@@ -39,6 +39,10 @@
 
 using namespace std;
 
+/* Prototypes */
+static bool append_file_to_dir(Session *session, const char **filename_ptr,
+                               const char *table_name);
+
 /**
   @defgroup Runtime_Environment Runtime Environment
   @{
@@ -67,9 +71,9 @@
 {
   if (session->locked_tables)
   {
-    session->lock=session->locked_tables;
-    session->locked_tables=0;			// Will be automatically closed
-    close_thread_tables(session);			// Free tables
+    session->lock= session->locked_tables;
+    session->locked_tables= 0;			// Will be automatically closed
+    session->close_thread_tables();			// Free tables
   }
 }
 
@@ -228,7 +232,7 @@
   {
     status_var_increment(session->status_var.com_other);
     session->my_eof();
-    close_thread_tables(session);			// Free before kill
+    session->close_thread_tables();			// Free before kill
     kill_drizzle();
     error=true;
     break;
@@ -297,9 +301,9 @@
 
   session->set_proc_info("closing tables");
   /* Free tables */
-  close_thread_tables(session);
+  session->close_thread_tables();
 
-  log_slow_statement(session);
+  logging_post_do(session);
 
   /* Store temp state for processlist */
   session->set_proc_info("cleaning up");
@@ -315,14 +319,6 @@
 }
 
 
-void log_slow_statement(Session *session)
-{
-  logging_post_do(session);
-
-  return;
-}
-
-
 /**
   Create a TableList object for an INFORMATION_SCHEMA table.
 
@@ -414,8 +410,8 @@
   TableList *table_list= (TableList*) select_lex->table_list.first;
   assert(table_list);
   table_list->schema_select_lex= schema_select_lex;
-  table_list->schema_table_reformed= 1;
-  return(0);
+
+  return 0;
 }
 
 /**
@@ -2605,8 +2601,8 @@
 
 /** If pointer is not a null pointer, append filename to it. */
 
-bool append_file_to_dir(Session *session, const char **filename_ptr,
-                        const char *table_name)
+static bool append_file_to_dir(Session *session, const char **filename_ptr,
+                               const char *table_name)
 {
   char buff[FN_REFLEN],*ptr, *end;
   if (!*filename_ptr)

=== modified file 'drizzled/sql_parse.h'
--- drizzled/sql_parse.h	2009-05-18 18:21:37 +0000
+++ drizzled/sql_parse.h	2009-05-30 22:30:05 +0000
@@ -85,11 +85,6 @@
 bool dispatch_command(enum enum_server_command command, Session *session,
                       char* packet, uint32_t packet_length);
 
-void log_slow_statement(Session *session);
-
-bool append_file_to_dir(Session *session, const char **filename_ptr,
-                        const char *table_name);
-
 bool reload_cache(Session *session, ulong options, TableList *tables);
 
 bool check_simple_select();

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-05-29 19:16:57 +0000
+++ drizzled/sql_table.cc	2009-05-30 22:30:05 +0000
@@ -2371,7 +2371,7 @@
       case  1:           // error, message written to net
         ha_autocommit_or_rollback(session, 1);
         session->endTransaction(ROLLBACK);
-        close_thread_tables(session);
+        session->close_thread_tables();
         continue;
       case -1:           // error, message could be written to net
         /* purecov: begin inspected */
@@ -2413,7 +2413,7 @@
       protocol->store(buff, length, system_charset_info);
       ha_autocommit_or_rollback(session, 0);
       session->endTransaction(COMMIT);
-      close_thread_tables(session);
+      session->close_thread_tables();
       lex->reset_query_tables_list(false);
       table->table=0;				// For query cache
       if (protocol->write())
@@ -2455,12 +2455,10 @@
 
     if (operator_func == &handler::ha_repair && !(check_opt->use_frm))
     {
-      if ((table->table->file->check_old_types() == HA_ADMIN_NEEDS_ALTER) ||
-          (table->table->file->ha_check_for_upgrade(check_opt) ==
-           HA_ADMIN_NEEDS_ALTER))
+      if ((table->table->file->check_old_types() == HA_ADMIN_NEEDS_ALTER))
       {
         ha_autocommit_or_rollback(session, 1);
-        close_thread_tables(session);
+        session->close_thread_tables();
         result_code= mysql_recreate_table(session, table);
         /*
           mysql_recreate_table() can push OK or ERROR.
@@ -2558,7 +2556,7 @@
         reopen the table and do ha_innobase::analyze() on it.
       */
       ha_autocommit_or_rollback(session, 0);
-      close_thread_tables(session);
+      session->close_thread_tables();
       TableList *save_next_local= table->next_local,
                  *save_next_global= table->next_global;
       table->next_local= table->next_global= 0;
@@ -2572,7 +2570,7 @@
       if (session->main_da.is_ok())
         session->main_da.reset_diagnostics_area();
       ha_autocommit_or_rollback(session, 0);
-      close_thread_tables(session);
+      session->close_thread_tables();
       if (!result_code) // recreation went ok
       {
         if ((table->table= open_ltable(session, table, lock_type, 0)) &&
@@ -2652,7 +2650,7 @@
     }
     ha_autocommit_or_rollback(session, 0);
     session->endTransaction(COMMIT);
-    close_thread_tables(session);
+    session->close_thread_tables();
     table->table=0;				// For query cache
     if (protocol->write())
       goto err;
@@ -2664,7 +2662,7 @@
 err:
   ha_autocommit_or_rollback(session, 1);
   session->endTransaction(ROLLBACK);
-  close_thread_tables(session);			// Shouldn't be needed
+  session->close_thread_tables();			// Shouldn't be needed
   if (table)
     table->table=0;
   return(true);
@@ -4628,7 +4626,7 @@
 	}
       }
       session->clear_error();
-      close_thread_tables(session);
+      session->close_thread_tables();
       table->table=0;				// For query cache
     }
     if (protocol->write())
@@ -4639,7 +4637,7 @@
   return(false);
 
  err:
-  close_thread_tables(session);			// Shouldn't be needed
+  session->close_thread_tables();			// Shouldn't be needed
   if (table)
     table->table=0;
   return(true);

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-05-29 06:43:29 +0000
+++ drizzled/table.cc	2009-05-30 22:30:05 +0000
@@ -49,8 +49,6 @@
 
 void open_table_error(TableShare *share, int error, int db_errno,
                       myf errortype, int errarg);
-static void fix_type_pointers(const char ***array, TYPELIB *point_to_type,
-                              uint32_t types, char **names);
 
 /*************************************************************************/
 
@@ -72,7 +70,7 @@
 
   DESCRIPTION
     Checks file name part starting with the rightmost '.' character,
-    and returns it if it is equal to '.frm'.
+    and returns it if it is equal to '.dfe'.
 
   TODO
     It is a good idea to get rid of this function modifying the code
@@ -285,8 +283,6 @@
     share->storage_engine= ha_resolve_by_name(session, &engine_name);
   }
 
-  share->mysql_version= DRIZZLE_VERSION_ID; // TODO: remove
-
   drizzled::message::Table::TableOptions table_options;
 
   if (table.has_options())
@@ -1531,12 +1527,6 @@
   return (error);
 }
 
-/* close_temporary_tables' internal, 4 is due to uint4korr definition */
-uint32_t  Table::tmpkeyval()
-{
-  return uint4korr(s->table_cache_key.str + s->table_cache_key.length - 4);
-}
-
 /*
   Free information allocated by openfrm
 
@@ -1587,148 +1577,6 @@
 }
 
 
-	/* Find where a form starts */
-	/* if formname is NULL then only formnames is read */
-
-ulong get_form_pos(File file, unsigned char *head, TYPELIB *save_names)
-{
-  uint32_t a_length,names,length;
-  unsigned char *pos,*buf;
-  ulong ret_value=0;
-
-  names=uint2korr(head+8);
-  a_length=(names+2)*sizeof(char *);		/* Room for two extra */
-
-  if (!save_names)
-    a_length=0;
-  else
-    save_names->type_names=0;			/* Clear if error */
-
-  if (names)
-  {
-    length=uint2korr(head+4);
-    lseek(file,64,SEEK_SET);
-    if (!(buf= (unsigned char*) malloc(length+a_length+names*4)) ||
-	my_read(file, buf+a_length, (size_t) (length+names*4),
-		MYF(MY_NABP)))
-    {						/* purecov: inspected */
-      if (buf)
-        free(buf);
-      return(0L);				/* purecov: inspected */
-    }
-    pos= buf+a_length+length;
-    ret_value=uint4korr(pos);
-  }
-  if (! save_names)
-  {
-    if (names)
-      free((unsigned char*) buf);
-  }
-  else if (!names)
-    memset(save_names, 0, sizeof(save_names));
-  else
-  {
-    char *str;
-    str=(char *) (buf+a_length);
-    fix_type_pointers((const char ***) &buf,save_names,1,&str);
-  }
-  return(ret_value);
-}
-
-
-/*
-  Read string from a file with malloc
-
-  NOTES:
-    We add an \0 at end of the read string to make reading of C strings easier
-*/
-
-int read_string(File file, unsigned char**to, size_t length)
-{
-
-  if (*to)
-    free(*to);
-  if (!(*to= (unsigned char*) malloc(length+1)) ||
-      my_read(file, *to, length,MYF(MY_NABP)))
-  {
-    if (*to)
-      free(*to);
-    *to= NULL;
-    return(1);                           /* purecov: inspected */
-  }
-  *((char*) *to+length)= '\0';
-  return (0);
-} /* read_string */
-
-
-	/* Add a new form to a form file */
-
-off_t make_new_entry(File file, unsigned char *fileinfo, TYPELIB *formnames,
-		     const char *newname)
-{
-  uint32_t i,bufflength,maxlength,n_length,length,names;
-  off_t endpos,newpos;
-  unsigned char buff[IO_SIZE];
-  unsigned char *pos;
-
-  length=(uint32_t) strlen(newname)+1;
-  n_length=uint2korr(fileinfo+4);
-  maxlength=uint2korr(fileinfo+6);
-  names=uint2korr(fileinfo+8);
-  newpos=uint4korr(fileinfo+10);
-
-  if (64+length+n_length+(names+1)*4 > maxlength)
-  {						/* Expand file */
-    newpos+=IO_SIZE;
-    int4store(fileinfo+10,newpos);
-    endpos= lseek(file,0,SEEK_END);/* Copy from file-end */
-    bufflength= (uint32_t) (endpos & (IO_SIZE-1));	/* IO_SIZE is a power of 2 */
-
-    while (endpos > maxlength)
-    {
-      lseek(file,(off_t) (endpos-bufflength),SEEK_SET);
-      if (my_read(file, buff, bufflength, MYF(MY_NABP+MY_WME)))
-        return(0L);
-      lseek(file,(off_t) (endpos-bufflength+IO_SIZE),SEEK_SET);
-      if ((my_write(file, buff,bufflength,MYF(MY_NABP+MY_WME))))
-        return(0);
-      endpos-=bufflength; bufflength=IO_SIZE;
-    }
-    memset(buff, 0, IO_SIZE);			/* Null new block */
-    lseek(file,(ulong) maxlength,SEEK_SET);
-    if (my_write(file,buff,bufflength,MYF(MY_NABP+MY_WME)))
-      return(0L);
-    maxlength+=IO_SIZE;				/* Fix old ref */
-    int2store(fileinfo+6,maxlength);
-    for (i=names, pos= (unsigned char*) *formnames->type_names+n_length-1; i--;
-         pos+=4)
-    {
-      endpos=uint4korr(pos)+IO_SIZE;
-      int4store(pos,endpos);
-    }
-  }
-
-  if (n_length == 1 )
-  {						/* First name */
-    length++;
-    sprintf((char*)buff,"/%s/",newname);
-  }
-  else
-    sprintf((char*)buff,"%s/",newname); /* purecov: inspected */
-  lseek(file, 63 + n_length,SEEK_SET);
-  if (my_write(file, buff, (size_t) length+1,MYF(MY_NABP+MY_WME)) ||
-      (names && my_write(file,(unsigned char*) (*formnames->type_names+n_length-1),
-			 names*4, MYF(MY_NABP+MY_WME))) ||
-      my_write(file, fileinfo+10, 4,MYF(MY_NABP+MY_WME)))
-    return(0L); /* purecov: inspected */
-
-  int2store(fileinfo+8,names+1);
-  int2store(fileinfo+4,n_length+length);
-  assert(ftruncate(file, newpos)==0);/* Append file with '\0' */
-  return(newpos);
-} /* make_new_entry */
-
-
 	/* error message when opening a form file */
 
 void TableShare::open_table_error(int pass_error, int db_errno, int pass_errarg)
@@ -1803,46 +1651,6 @@
 } /* open_table_error */
 
 
-	/*
-	** fix a str_type to a array type
-	** typeparts separated with some char. differents types are separated
-	** with a '\0'
-	*/
-
-static void
-fix_type_pointers(const char ***array, TYPELIB *point_to_type, uint32_t types,
-		  char **names)
-{
-  char *type_name, *ptr;
-  char chr;
-
-  ptr= *names;
-  while (types--)
-  {
-    point_to_type->name=0;
-    point_to_type->type_names= *array;
-
-    if ((chr= *ptr))			/* Test if empty type */
-    {
-      while ((type_name=strchr(ptr+1,chr)) != NULL)
-      {
-	*((*array)++) = ptr+1;
-	*type_name= '\0';		/* End string */
-	ptr=type_name;
-      }
-      ptr+=2;				/* Skip end mark and last 0 */
-    }
-    else
-      ptr++;
-    point_to_type->count= (uint32_t) (*array - point_to_type->type_names);
-    point_to_type++;
-    *((*array)++)= NULL;		/* End of type */
-  }
-  *names=ptr;				/* Update end */
-  return;
-} /* fix_type_pointers */
-
-
 TYPELIB *typelib(MEM_ROOT *mem_root, List<String> &strings)
 {
   TYPELIB *result= (TYPELIB*) alloc_root(mem_root, sizeof(TYPELIB));
@@ -2002,68 +1810,6 @@
   return (my_rename(from_s.c_str(),to_s.c_str(),MYF(MY_WME)));
 }
 
-
-/*
-  Allocate string field in MEM_ROOT and return it as String
-
-  SYNOPSIS
-    get_field()
-    mem   	MEM_ROOT for allocating
-    field 	Field for retrieving of string
-    res         result String
-
-  RETURN VALUES
-    1   string is empty
-    0	all ok
-*/
-
-bool get_field(MEM_ROOT *mem, Field *field, String *res)
-{
-  char buff[MAX_FIELD_WIDTH], *to;
-  String str(buff,sizeof(buff),&my_charset_bin);
-  uint32_t length;
-
-  field->val_str(&str);
-  if (!(length= str.length()))
-  {
-    res->length(0);
-    return 1;
-  }
-  if (!(to= strmake_root(mem, str.ptr(), length)))
-    length= 0;                                  // Safety fix
-  res->set(to, length, ((Field_str*)field)->charset());
-  return 0;
-}
-
-
-/*
-  Allocate string field in MEM_ROOT and return it as NULL-terminated string
-
-  SYNOPSIS
-    get_field()
-    mem   	MEM_ROOT for allocating
-    field 	Field for retrieving of string
-
-  RETURN VALUES
-    NULL  string is empty
-    #      pointer to NULL-terminated string value of field
-*/
-
-char *get_field(MEM_ROOT *mem, Field *field)
-{
-  char buff[MAX_FIELD_WIDTH], *to;
-  String str(buff,sizeof(buff),&my_charset_bin);
-  uint32_t length;
-
-  field->val_str(&str);
-  length= str.length();
-  if (!length || !(to= (char*) alloc_root(mem,length+1)))
-    return NULL;
-  memcpy(to,str.ptr(),(uint32_t) length);
-  to[length]=0;
-  return to;
-}
-
 /*
   DESCRIPTION
     given a buffer with a key value, and a map of keyparts
@@ -2178,149 +1924,6 @@
 }
 
 
-/**
-  Checks whether a table is intact. Should be done *just* after the table has
-  been opened.
-
-  @param[in] table             The table to check
-  @param[in] table_f_count     Expected number of columns in the table
-  @param[in] table_def         Expected structure of the table (column name
-                               and type)
-
-  @retval  false  OK
-  @retval  TRUE   There was an error. An error message is output
-                  to the error log.  We do not push an error
-                  message into the error stack because this
-                  function is currently only called at start up,
-                  and such errors never reach the user.
-*/
-
-bool
-Table::table_check_intact(const uint32_t table_f_count,
-                          const TABLE_FIELD_W_TYPE *table_def)
-{
-  uint32_t i;
-  bool error= false;
-  bool fields_diff_count;
-
-  fields_diff_count= (s->fields != table_f_count);
-  if (fields_diff_count)
-  {
-
-    /* previous MySQL version */
-    if (DRIZZLE_VERSION_ID > s->mysql_version)
-    {
-      errmsg_printf(ERRMSG_LVL_ERROR, ER(ER_COL_COUNT_DOESNT_MATCH_PLEASE_UPDATE),
-                      alias, table_f_count, s->fields,
-                      s->mysql_version, DRIZZLE_VERSION_ID);
-      return(true);
-    }
-    else if (DRIZZLE_VERSION_ID == s->mysql_version)
-    {
-      errmsg_printf(ERRMSG_LVL_ERROR, ER(ER_COL_COUNT_DOESNT_MATCH_CORRUPTED), alias,
-                      table_f_count, s->fields);
-      return(true);
-    }
-    /*
-      Something has definitely changed, but we're running an older
-      version of MySQL with new system tables.
-      Let's check column definitions. If a column was added at
-      the end of the table, then we don't care much since such change
-      is backward compatible.
-    */
-  }
-  char buffer[STRING_BUFFER_USUAL_SIZE];
-  for (i=0 ; i < table_f_count; i++, table_def++)
-  {
-    String sql_type(buffer, sizeof(buffer), system_charset_info);
-    sql_type.length(0);
-    if (i < s->fields)
-    {
-      Field *cur_field= this->field[i];
-
-      if (strncmp(cur_field->field_name, table_def->name.str,
-                  table_def->name.length))
-      {
-        /*
-          Name changes are not fatal, we use ordinal numbers to access columns.
-          Still this can be a sign of a tampered table, output an error
-          to the error log.
-        */
-        errmsg_printf(ERRMSG_LVL_ERROR, _("Incorrect definition of table %s.%s: "
-                        "expected column '%s' at position %d, found '%s'."),
-                        s->db.str, alias, table_def->name.str, i,
-                        cur_field->field_name);
-      }
-      cur_field->sql_type(sql_type);
-      /*
-        Generally, if column types don't match, then something is
-        wrong.
-
-        However, we only compare column definitions up to the
-        length of the original definition, since we consider the
-        following definitions compatible:
-
-        1. DATETIME and DATETIM
-        2. INT(11) and INT(11
-        3. SET('one', 'two') and SET('one', 'two', 'more')
-
-        For SETs or ENUMs, if the same prefix is there it's OK to
-        add more elements - they will get higher ordinal numbers and
-        the new table definition is backward compatible with the
-        original one.
-       */
-      if (strncmp(sql_type.c_ptr_safe(), table_def->type.str,
-                  table_def->type.length - 1))
-      {
-        errmsg_printf(ERRMSG_LVL_ERROR,
-                      _("Incorrect definition of table %s.%s: "
-                        "expected column '%s' at position %d to have type "
-                        "%s, found type %s."),
-                      s->db.str, alias,
-                      table_def->name.str, i, table_def->type.str,
-                      sql_type.c_ptr_safe());
-        error= true;
-      }
-      else if (table_def->cset.str && !cur_field->has_charset())
-      {
-        errmsg_printf(ERRMSG_LVL_ERROR,
-                      _("Incorrect definition of table %s.%s: "
-                        "expected the type of column '%s' at position %d "
-                        "to have character set '%s' but the type has no "
-                        "character set."),
-                      s->db.str, alias,
-                      table_def->name.str, i, table_def->cset.str);
-        error= true;
-      }
-      else if (table_def->cset.str &&
-               strcmp(cur_field->charset()->csname, table_def->cset.str))
-      {
-        errmsg_printf(ERRMSG_LVL_ERROR,
-                      _("Incorrect definition of table %s.%s: "
-                        "expected the type of column '%s' at position %d "
-                        "to have character set '%s' but found "
-                        "character set '%s'."),
-                      s->db.str, alias,
-                      table_def->name.str, i, table_def->cset.str,
-                      cur_field->charset()->csname);
-        error= true;
-      }
-    }
-    else
-    {
-      errmsg_printf(ERRMSG_LVL_ERROR,
-                    _("Incorrect definition of table %s.%s: "
-                      "expected column '%s' at position %d to have type %s "
-                      " but the column is not found."),
-                    s->db.str, alias,
-                    table_def->name.str, i, table_def->type.str);
-      error= true;
-    }
-  }
-  return(error);
-}
-
-
 /*
   Create Item_field for each column in the table.
 
@@ -2353,32 +1956,6 @@
   return false;
 }
 
-/*
-  Reset an existing list of Item_field items to point to the
-  Fields of this table.
-
-  SYNPOSIS
-    Table::fill_item_list()
-      item_list          a non-empty list with Item_fields
-
-  DESCRIPTION
-    This is a counterpart of fill_item_list used to redirect
-    Item_fields to the fields of a newly created table.
-    The caller must ensure that number of items in the item_list
-    is the same as the number of columns in the table.
-*/
-
-void Table::reset_item_list(List<Item> *item_list) const
-{
-  List_iterator_fast<Item> it(*item_list);
-  for (Field **ptr= field; *ptr; ptr++)
-  {
-    Item_field *item_field= (Item_field*) it++;
-    assert(item_field != 0);
-    item_field->reset_field(*ptr);
-  }
-}
-
 
 /*
   Find underlying base tables (TableList) which represent given
@@ -2807,37 +2384,6 @@
     mark_auto_increment_column();
 }
 
-
-/*
-  Cleanup this table for re-execution.
-
-  SYNOPSIS
-    TableList::reinit_before_use()
-*/
-
-void TableList::reinit_before_use(Session *session)
-{
-  /*
-    Reset old pointers to TABLEs: they are not valid since the tables
-    were closed in the end of previous prepare or execute call.
-  */
-  table= 0;
-  /* Reset is_schema_table_processed value(needed for I_S tables */
-  schema_table_state= NOT_PROCESSED;
-
-  TableList *embedded; /* The table at the current level of nesting. */
-  TableList *parent_embedding= this; /* The parent nested table reference. */
-  do
-  {
-    embedded= parent_embedding;
-    if (embedded->prep_on_expr)
-      embedded->on_expr= embedded->prep_on_expr->copy_andor_structure(session);
-    parent_embedding= embedded->embedding;
-  }
-  while (parent_embedding &&
-         parent_embedding->nested_join->join_list.head() == embedded);
-}
-
 /*
   Return subselect that contains the FROM list this table is taken from
 

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-05-29 06:43:29 +0000
+++ drizzled/table.h	2009-05-30 22:30:05 +0000
@@ -163,7 +163,6 @@
   bool get_fields_in_item_tree;      /* Signal to fix_field */
   int report_error(int error);
   int closefrm(bool free_share);
-  uint32_t tmpkeyval();
 
   /*
    The ID of the query that opened and is using this table. Has different
@@ -436,7 +435,6 @@
   inline uint32_t getDBStat () { return db_stat; }
   inline uint32_t setDBStat () { return db_stat; }
   bool fill_item_list(List<Item> *item_list) const;
-  void reset_item_list(List<Item> *item_list) const;
   void clear_column_bitmaps(void);
   void prepare_for_position(void);
   void mark_columns_used_by_index_no_reset(uint32_t index, MY_BITMAP *map);

=== modified file 'drizzled/table_list.h'
--- drizzled/table_list.h	2009-05-27 19:47:42 +0000
+++ drizzled/table_list.h	2009-05-30 22:30:05 +0000
@@ -91,7 +91,6 @@
     natural_join(NULL),
     is_natural_join(false),
     is_join_columns_complete(false),
-    schema_table_reformed(false),
     straight(false),
     updating(false), 
     force_index(false),
@@ -189,12 +188,6 @@
   /* true if join_columns contains all columns of this table reference. */
   bool is_join_columns_complete;
 
-  /*
-    True when the view field translation table is used to convert
-    schema table fields for backwards compatibility with SHOW command.
-  */
-  bool schema_table_reformed;
-
   bool		straight;		/* optimize with prev table */
   bool          updating;               /* for replicate-do/ignore table */
   bool		force_index;		/* prefer index over table scan */
@@ -296,11 +289,6 @@
   inline TableList *top_table()
     { return this; }
 
-  /*
-    Cleanup for re-execution in a prepared statement or a stored
-    procedure.
-  */
-  void reinit_before_use(Session *session);
   Item_subselect *containing_subselect();
 
   /*

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2009-05-30 01:39:28 +0000
+++ drizzled/table_share.h	2009-05-30 22:30:05 +0000
@@ -83,7 +83,6 @@
 
   uint32_t   avg_row_length;		/* create information */
   uint32_t   block_size;                   /* create information */
-  uint32_t   mysql_version;
   uint32_t   version;
   uint32_t   timestamp_offset;		/* Set to offset+1 of record */
   uint32_t   reclength;			/* Recordlength */

